var DocList = (function () {
    function DocList() {
    }
    DocList.prototype.getDocListSuccess = function (data) {
        for(var i = 0; i < data.items.length; i++) {
            var props = data.items[i].node.properties;
            var name = props["cm:name"];
            var title = props["cm:title"];
            var created = props["cm:created"];
            var modified = props["cm:modified"];
            var row = {
                'name': name,
                'title': title,
                'created': created.value,
                'modified': modified.value
            };
            this.folderTable.addRow(row);
        }
    };
    DocList.prototype.getDocListError = function (err) {
    };
    DocList.prototype.init = function (htmlId) {
        YUI().use("datatable", function (Y) {
            this.folderTable = new Y.DataTable({
                columns: [
                    {
                        key: "name",
                        width: '200px'
                    }, 
                    {
                        key: "title",
                        width: '200px'
                    }, 
                    {
                        key: "created",
                        width: '200px'
                    }, 
                    {
                        key: "modified",
                        width: '200px'
                    }, 
                    {
                        key: " ",
                        width: '400'
                    }
                ],
                data: [],
                sortable: true
            });
            this.folderTable.render("#" + htmlId);
        });
    };
    DocList.prototype.loadData = function (conn) {
        conn.getDocList({
            site: 's1',
            model: 'cm:content',
            container: 'documentLibrary',
            folderPath: '/'
        }, this.getDocListSuccess, this.getDocListError);
    };
    return DocList;
})();
var RepoTree = (function () {
    function RepoTree() {
    }
    RepoTree.prototype.init = function (htmlId) {
        YUI({
            gallery: 'gallery-2012.08.29-20-10'
        }).use("gallery-yui3treeview-ng", function (Y) {
            this.treeView = new Y.TreeView({
                startCollapsed: false,
                children: [
                    {
                        label: "Root",
                        children: [
                            {
                                label: "sub 1",
                                children: [
                                    {
                                        label: "sub 1-1"
                                    }, 
                                    {
                                        label: "sub 1-2"
                                    }, 
                                    
                                ]
                            }, 
                            {
                                label: "sub 2",
                                children: [
                                    {
                                        label: "sub 2-1"
                                    }, 
                                    {
                                        label: "sub 2-2",
                                        children: [
                                            {
                                                label: "sub 2-2-1"
                                            }, 
                                            {
                                                label: "sub 2-2-2"
                                            }
                                        ]
                                    }, 
                                    
                                ]
                            }
                        ]
                    }
                ]
            });
            this.treeView.render("#" + htmlId);
            var r = Y.one("#report1");
            this.treeView.on("nodeclick", function (e) {
                var node = e.treenode, label = node.get("label"), isLeaf = node.get("isLeaf"), collapsed = node.get("collapsed");
                r.setContent("");
                r.appendChild("<li>You clicked " + (isLeaf ? "leaf" : "node") + " " + label);
                r.appendChild("<li>Path to root is: " + node.path().join(" > "));
                r.appendChild("<li>State is: " + (collapsed ? "collapsed" : "expanded"));
            });
        });
    };
    return RepoTree;
})();
var repoTree = new RepoTree();
var docList = new DocList();
var conn;
var AppViewModel = (function () {
    function AppViewModel() {
    }
    AppViewModel.prototype.login = function () {
        conn = AlfJS.createConnection({
            hostname: 'localhost',
            login: 'admin',
            password: 'admin',
            protocol: 'http',
            port: 8080,
            serviceBase: 'alfresco/service/',
            format: 'jsonp',
            prefix: ''
        });
        conn.login(this.loginSuccess, this.loginError);
    };
    AppViewModel.prototype.loginSuccess = function (data) {
        var ticket = conn.getTicket();
        docList.loadData(conn);
    };
    AppViewModel.prototype.loginError = function (err) {
        var error = JSON.parse(err.responseText);
    };
    return AppViewModel;
})();
window.onload = function () {
    repoTree.init("repotree");
    docList.init("folderlistdatatable");
    var appViewModel = new AppViewModel();
    ko.applyBindings(appViewModel);
};
//sourceMappingURL=app.js.map